#ifndef _DEFS_H
#define _DEFS_H

#define MAX_LIVES           5
#define MONSTER_SPEED       0.5
#define MONSTER_FRAME_SPEED 10
#define DOWN_SPEED          2
#define WIZARD_SPEED        10
#define WATERFALL_SPEED     10
#define MONEY_SPEED         10
#define QUESTION_SPEED      10
#define FOREST_SPEED        10
#define MARIO_FRAME_SPEED   10
#define VERSION             4.0
#define WIZARD_BEG          90

#define COPYRIGHT           "MARIO - by MATI Inc. 1998"

typedef unsigned char uchar;
typedef unsigned int uint;

const uchar BEGS[6] = {8, 25, 26, 53, 61, 79};
const char *map_magic = "MAP";

/*uchar INTRO_DATA[6][10] = {{0 ,0 ,0 ,0 ,0 ,8 ,0 ,0 ,0 ,0 },
                           {0 ,8 ,0 ,0 ,10,9 ,11,8 ,0 ,0 },
                           {10,9 ,11,8 ,0 ,22,10,9 ,11,0 },
                           {0 ,22,10,9 ,11,22,0 ,23,0 ,0 },
                           {0 ,22,0 ,23,0 ,22,0 ,23,0 ,0 },
                           {12,13,13,13,13,13,13,13,13,14}}; */

struct wav {
  char RIFF[4];
  long datalen;
  char wavefmt[8];
  long size;
  uint PCM;
  uint channels;
  long freq;
  long bytes_per_sec;
  uint blocklen;
  uint bits_ber_sample;
  uint extra;
  char data[4];
};

struct level_info {
  char magic[4];
  uchar width;
  uchar height;
  uint num_objects;
  char name[18];
};

struct item {
  uchar type;
  uchar sprite;
  uchar dir;
  uchar x, y;
  item *next;
};

struct trigger_change_level {
  char map[12];
  uchar x, y, w;
};

struct trigger_teleport {
  uchar x, y, w;
  uchar to_x, to_y;
};

#endif
