#ifndef _PAL_H
#define _PAL_H
#include "wad.h"
#include "defs.h"
#include "graphics.h"

void load_pal(char *filename);
void fade_in();
void fade_out();
void set_all_pal();
void set_null_pal();
void scroll_pal(int start, int len);
void set_rgb_pal(uchar n, uchar r, uchar g, uchar b);

uchar pal[1024];

void load_pal(char *filename)
{
  W_Read(filename, 0, 1024, (void *)pal);
}

void set_rgb_pal(uchar n, uchar r, uchar g, uchar b)
{
  pal[n * 4 + 2] = r;
  pal[n * 4 + 1] = g;
  pal[n * 4] = b;
}

void set_all_pal()
{
  for (int i = 1; i < 256; i++)
    set_rgb(i, pal[i * 4 + 2], pal[i * 4 + 1], pal[i * 4]);
}

void set_null_pal()
{
  for (int i = 0; i < 256; i++)
    set_rgb(i, 0, 0, 0);
}

uchar div_pal(uchar b, int n)
{
  return b * 100 / 63 * n / 100;
}

void fade_in()
{
  for (int j = 0; j < 64; j++)
  {
    for (int i = 0; i < 256; i++)
      set_rgb(i, div_pal(pal[i * 4 + 2], j),
                 div_pal(pal[i * 4 + 1], j),
                 div_pal(pal[i * 4], j));
    vert_ret();
  }
}

void fade_out()
{
  for (int j = 63; j >= 0; j--)
  {
    for (int i = 0; i < 256; i++)
      set_rgb(i, div_pal(pal[i * 4 + 2], j),
                 div_pal(pal[i * 4 + 1], j),
                 div_pal(pal[i * 4], j));
    vert_ret();
  }
}

void scroll_pal(int start, int len)
{
  uchar r = pal[(start + len) * 4 + 2];
  uchar g = pal[(start + len) * 4 + 1];
  uchar b = pal[(start + len) * 4];

  for (int i = len; i > 0; i--)
  {
    set_rgb(i + start, pal[(i - 1 + start) * 4 + 2], pal[(i - 1 + start) * 4 + 1], pal[(i - 1 + start) * 4]);
    set_rgb_pal(i + start, pal[(i - 1 + start) * 4 + 2], pal[(i - 1 + start) * 4 + 1], pal[(i - 1 + start) * 4]);
  }

  set_rgb(start, r, g, b);
  set_rgb_pal(start, r, g, b);
};

#endif
