#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <math.h>
#include "error.h"
#include "defs.h"
#include "wad.h"
#include "pal.h"
#include "graphics.h"
#include "mouse.h"

void far *screen = farmalloc(64000);
void far *data = farmalloc(16384);
void far *panel = farmalloc(15200);

unsigned char tank[73][48];

double Pi = 0.017453292;

struct tank_coord {
  int x, y;
  int angle;
};

char level[32][32];
int screen_x, screen_y;

class Tank {
    double speed;
    int turbo;
    double fast;
    double slow;
    double inc;
    double vector_x, vector_y;
    int R, L, U, D;
    Tank *next;
  public:
    tank_coord coords, old_coords;
    Tank();
    void run(unsigned char key);
    void draw();
    void update_map();
    ~Tank();
};

Tank *self = new Tank();

Tank::Tank()
{
  speed = 0;
  fast = 4;
  slow = 2;
  inc = 0.1;
  vector_x = 100;
  vector_y = 100;
  coords.x = (int)vector_x;
  coords.y = (int)vector_y;
  coords.angle = random(360);
  R = 0;
  L = 0;
  U = 0;
  D = 0;
  turbo = 0;
  old_coords = coords;
}

void Tank::run(unsigned char key)
{
  double limit;

  switch (key)
  {
    case 205: R = 0; break;
    case 203: L = 0; break;
    case 200: U = 0; break;
    case 208: D = 0; break;
    case 77: R = 1; L = 0; break;
    case 75: L = 1; R = 0; break;
    case 80: D = 1; U = 0; break;
    case 72: U = 1; D = 0; break;
    case 29: turbo = 1; break;
    case 157: turbo = 0;
  }

  if (R) coords.angle += 3;
  if (L) coords.angle -= 3;

  if (coords.angle > 359) coords.angle = 0;
  if (coords.angle < 0) coords.angle = 359;

  if (level[coords.x / 32][coords.y / 32] != 11)
  {
    limit = slow;
    if (speed < 0 && speed < -limit - limit * turbo) speed = -limit;
    if (speed > 0 && speed > limit + limit * turbo) speed = limit;
  }
  else
    limit = fast;

  if (U)
  {
    if (speed > -limit - limit * turbo) speed -= inc;
  }
  if (D)
  {
    if (speed < limit + limit * turbo) speed += inc;
  }

  if (!U && !D)
  {
    if (speed > 0)
    {
      speed -= inc;
    }
    if (speed < 0)
    {
      speed += inc;
    }
  }

  vector_x += (cos((coords.angle - 90) * Pi) * (speed + speed * 0));
  vector_y += (sin((coords.angle - 90) * Pi) * (speed + speed * 0));

  if (vector_x < 0) vector_x = 0;
  if (vector_y < 0) vector_y = 0;
  if (vector_x > 1023) vector_x = 1023;
  if (vector_y > 1023) vector_y = 1023;

  coords.x = (int)vector_x;
  coords.y = (int)vector_y;

  screen_x = coords.x - 122;
  screen_y = coords.y - 100;

  if (screen_x < 0) screen_x = 0;
  if (screen_y < 0) screen_y = 0;
  if (screen_x > 780) screen_x = 780;
  if (screen_y > 824) screen_y = 824;

  update_map();
  old_coords = coords;
}

void Tank::draw()
{
  double x_, y_, x__, y__;
  int x = coords.x - screen_x + 76, y = coords.y - screen_y;

  if (x > - 80 && y > -80 && x < 400 && y < 280)

  for (int i = 0; i < 46; i++)
    for (int j = 0; j < 73; j++)
      if (tank[j][i] != RENDER_COLOR)
      {
        y_ = sin(coords.angle * Pi);
        x_ = cos(coords.angle * Pi);

        y__ = y_ * (23 - i) / 1.1 + x_ * (36 - j);
        x__ = x_ * (23 - i) - y_ * (36 - j) * 1.1;

        put_pixel(x + x__, y + y__, tank[j][i]);
        put_pixel(x + x__ + 1, y + y__, tank[j][i]);
      }
}

void Tank::update_map()
{
  bar(old_coords.x / 32 * 2 + 6, old_coords.y / 32 * 2 + 6, 2, 2, 0);
  bar(coords.x / 32 * 2 + 6, coords.y / 32 * 2 + 6, 2, 2, RENDER_COLOR);
}

Tank::~Tank()
{
}

void refresh()
{
  for (int i = screen_x / 32; i < screen_x / 32 + 9; i++)
    for (int j = screen_y / 32; j < screen_y / 32 + 8; j++)
      if (i == screen_x / 32)
        put_image(76, j * 32 - screen_y, 32, 32, level[i][j] % 2 * 32 + screen_x % 32, level[i][j] / 2 * 32, 64, data);
      else
        put_image(i * 32 - screen_x + 76, j * 32 - screen_y, 32, 32, level[i][j] % 2 * 32, level[i][j] / 2 * 32, 64, data);

  self -> draw();

  copy_to_screen();
}

void draw_panel()
{
  put_image(0, 0, 76, 200, 0, 0, 76, panel);
}

void main()
{
  unsigned char key;

  randomize();
  W_Init("tank.wad");
  load_pal("PAL.DAT");
  load_font("FONT.DAT");
  W_Read("LEVEL.DAT", 0, 1024, level);
  W_Read("GFX.DAT", 0, 16384, (char *)data);
  W_Read("TANK.DAT", 0, 3504, tank);
  W_Read("PANEL.DAT", 0, 15200, panel);

  self -> run(0);

  set_mode(0x13);
  set_screen_buf(screen);
  set_null_pal();
  draw_panel();
  refresh();
  fade_in();

  do
  {
    asm
    {
      cli
      in al, 60h
      mov key, al
    }


    self -> run(key);

    refresh();
    vert_ret();

    asm
    {
      sti
      mov ax, 0C00h
      int 21h
    }
  }
  while (key != 1);

  delete self;
  fade_out();
  set_mode(3);
  W_Close();
}
